/* Generated by the protocol buffer compiler.  DO NOT EDIT! */
/* Generated from: smhpbedb.proto */

#ifndef PROTOBUF_C_smhpbedb_2eproto__INCLUDED
#define PROTOBUF_C_smhpbedb_2eproto__INCLUDED

#include <protobuf-c/protobuf-c.h>

PROTOBUF_C__BEGIN_DECLS

#if PROTOBUF_C_VERSION_NUMBER < 1003000
# error This file was generated by a newer version of protoc-c which is incompatible with your libprotobuf-c headers. Please update your headers.
#elif 1003002 < PROTOBUF_C_MIN_COMPILER_VERSION
# error This file was generated by an older version of protoc-c which is incompatible with your libprotobuf-c headers. Please regenerate this file with a newer version of protoc-c.
#endif


typedef struct _SMH__PBEDB SMH__PBEDB;
typedef struct _SMH__PBEDBService SMH__PBEDBService;
typedef struct _SMH__PBEDBRoom SMH__PBEDBRoom;
typedef struct _SMH__PBEDBPeripheral SMH__PBEDBPeripheral;
typedef struct _SMH__PBEDBCluster SMH__PBEDBCluster;
typedef struct _SMH__PBEDBAttribute SMH__PBEDBAttribute;
typedef struct _SMH__PBEDBBinding SMH__PBEDBBinding;
typedef struct _SMH__PBEDBAutomation SMH__PBEDBAutomation;
typedef struct _SMH__PBEDBScheduler SMH__PBEDBScheduler;
typedef struct _SMH__PBEDBAction SMH__PBEDBAction;
typedef struct _SMH__PBEDBCondition SMH__PBEDBCondition;
typedef struct _SMH__PBEDBSubscriber SMH__PBEDBSubscriber;
typedef struct _SMH__PBEDBUpdate SMH__PBEDBUpdate;
typedef struct _SMH__PBEDBEvent SMH__PBEDBEvent;
typedef struct _SMH__PBEDBCommand SMH__PBEDBCommand;


/* --- enums --- */

typedef enum _SMH__PBEDB__Partition {
  SMH__PBEDB__PARTITION__PARTITION_DASHBOARD = 0,
  SMH__PBEDB__PARTITION__PARTITION_WIZARD = 1
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDB__PARTITION)
} SMH__PBEDB__Partition;
typedef enum _SMH__PBEDBRoom__Type {
  SMH__PBEDBROOM__TYPE__TYPE_NONE = 0,
  SMH__PBEDBROOM__TYPE__TYPE_LIVING = 3,
  SMH__PBEDBROOM__TYPE__TYPE_KITCHEN = 8
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBROOM__TYPE)
} SMH__PBEDBRoom__Type;
typedef enum _SMH__PBEDBPeripheral__Type {
  SMH__PBEDBPERIPHERAL__TYPE__TYPE_NONE = 0,
  SMH__PBEDBPERIPHERAL__TYPE__TYPE_DEVICE = 1,
  SMH__PBEDBPERIPHERAL__TYPE__TYPE_GROUP = 2
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBPERIPHERAL__TYPE)
} SMH__PBEDBPeripheral__Type;
typedef enum _SMH__PBEDBPeripheral__GroupType {
  SMH__PBEDBPERIPHERAL__GROUP_TYPE__GROUP_TYPE_NONE = 0,
  SMH__PBEDBPERIPHERAL__GROUP_TYPE__GROUP_TYPE_USER = 1
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBPERIPHERAL__GROUP_TYPE)
} SMH__PBEDBPeripheral__GroupType;
typedef enum _SMH__PBEDBPeripheral__GroupSign {
  SMH__PBEDBPERIPHERAL__GROUP_SIGN__GROUP_SIGN_NONE = 0
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBPERIPHERAL__GROUP_SIGN)
} SMH__PBEDBPeripheral__GroupSign;
typedef enum _SMH__PBEDBPeripheral__DeviceType {
  SMH__PBEDBPERIPHERAL__DEVICE_TYPE__DEVICE_TYPE_NONE = 0,
  SMH__PBEDBPERIPHERAL__DEVICE_TYPE__DEVICE_TYPE_SOCKET = 81,
  SMH__PBEDBPERIPHERAL__DEVICE_TYPE__DEVICE_TYPE_CCT = 268,
  SMH__PBEDBPERIPHERAL__DEVICE_TYPE__DEVICE_TYPE_RGB_CCT = 269,
  SMH__PBEDBPERIPHERAL__DEVICE_TYPE__DEVICE_TYPE_TEMPERATURE = 770,
  SMH__PBEDBPERIPHERAL__DEVICE_TYPE__DEVICE_TYPE_KEYCHAIN = 1025,
  SMH__PBEDBPERIPHERAL__DEVICE_TYPE__DEVICE_TYPE_IAS = 1026,
  SMH__PBEDBPERIPHERAL__DEVICE_TYPE__DEVICE_TYPE_SIREN = 1027
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBPERIPHERAL__DEVICE_TYPE)
} SMH__PBEDBPeripheral__DeviceType;
typedef enum _SMH__PBEDBPeripheral__DeviceCategory {
  SMH__PBEDBPERIPHERAL__DEVICE_CATEGORY__DEVICE_CATEGORY_NONE = 0,
  SMH__PBEDBPERIPHERAL__DEVICE_CATEGORY__DEVICE_CATEGORY_APPLIANCE = 1,
  SMH__PBEDBPERIPHERAL__DEVICE_CATEGORY__DEVICE_CATEGORY_LIGHTING = 2,
  SMH__PBEDBPERIPHERAL__DEVICE_CATEGORY__DEVICE_CATEGORY_SENSOR = 3,
  SMH__PBEDBPERIPHERAL__DEVICE_CATEGORY__DEVICE_CATEGORY_KEYCHAIN = 5,
  SMH__PBEDBPERIPHERAL__DEVICE_CATEGORY__DEVICE_CATEGORY_SIREN = 6
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBPERIPHERAL__DEVICE_CATEGORY)
} SMH__PBEDBPeripheral__DeviceCategory;
typedef enum _SMH__PBEDBPeripheral__DeviceSign {
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_NONE = 0,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_LAMP = 1,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_MOTION = 11,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_LEAKAGE = 15,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_DOOR = 17,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_TEMPERATURE = 13,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_SOCKET = 18,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_SMOKE = 20,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_KEYCHAIN = 21,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_SIREN = 22,
  SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_GAS = 23
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBPERIPHERAL__DEVICE_SIGN)
} SMH__PBEDBPeripheral__DeviceSign;
typedef enum _SMH__PBEDBCluster__ID {
  SMH__PBEDBCLUSTER__ID__ID_BASIC = 0,
  SMH__PBEDBCLUSTER__ID__ID_POWER = 1,
  SMH__PBEDBCLUSTER__ID__ID_IDENTIFY = 3,
  SMH__PBEDBCLUSTER__ID__ID_GROUPS = 4,
  SMH__PBEDBCLUSTER__ID__ID_ON_OFF = 6,
  SMH__PBEDBCLUSTER__ID__ID_LEVEL = 8,
  SMH__PBEDBCLUSTER__ID__ID_OTA = 25,
  SMH__PBEDBCLUSTER__ID__ID_COLOR = 768,
  SMH__PBEDBCLUSTER__ID__ID_TEMPERATURE = 1026,
  SMH__PBEDBCLUSTER__ID__ID_HUMIDITY = 1029,
  SMH__PBEDBCLUSTER__ID__ID_IAS = 1280,
  SMH__PBEDBCLUSTER__ID__ID_SIREN = 1282,
  SMH__PBEDBCLUSTER__ID__ID_NOTIFICATION = 25500,
  SMH__PBEDBCLUSTER__ID__ID_SCRIPT = 25700,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_GAS = 65522,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_SMOKE = 65524,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_KEYCHAIN = 65525,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_MOTION = 65526,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_DOOR = 65527,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_LEAKAGE = 65529,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_SIREN = 65530,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_SOCKET = 65531,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_RGB_CCT = 65533,
  SMH__PBEDBCLUSTER__ID__ID_HEIMAN_CCT = 65534
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBCLUSTER__ID)
} SMH__PBEDBCluster__ID;
typedef enum _SMH__PBEDBAttribute__Key {
  SMH__PBEDBATTRIBUTE__KEY__KEY_BASIC_ZCL_VERSIONS = 0,
  SMH__PBEDBATTRIBUTE__KEY__KEY_BASIC_MANUFACTURER = 4,
  SMH__PBEDBATTRIBUTE__KEY__KEY_BASIC_MODEL = 5,
  SMH__PBEDBATTRIBUTE__KEY__KEY_BASIC_POWER_SOURCE = 7,
  SMH__PBEDBATTRIBUTE__KEY__KEY_POWER_PERCENTAGE = 33,
  SMH__PBEDBATTRIBUTE__KEY__KEY_IDENTIFY_TIME = 0,
  SMH__PBEDBATTRIBUTE__KEY__KEY_GROUPS_GROUPS = 0,
  SMH__PBEDBATTRIBUTE__KEY__KEY_ON_OFF_VALUE = 0,
  SMH__PBEDBATTRIBUTE__KEY__KEY_LEVEL_VALUE = 0,
  SMH__PBEDBATTRIBUTE__KEY__KEY_OTA_VERSION = 2,
  SMH__PBEDBATTRIBUTE__KEY__KEY_COLOR_HUE = 0,
  SMH__PBEDBATTRIBUTE__KEY__KEY_COLOR_SATURATION = 1,
  SMH__PBEDBATTRIBUTE__KEY__KEY_COLOR_TEMPERATURE = 7,
  SMH__PBEDBATTRIBUTE__KEY__KEY_COLOR_MODE = 8,
  SMH__PBEDBATTRIBUTE__KEY__KEY_TEMPERATURE_VALUE = 0,
  SMH__PBEDBATTRIBUTE__KEY__KEY_TEMPERATURE_MIN = 1,
  SMH__PBEDBATTRIBUTE__KEY__KEY_TEMPERATURE_MAX = 2,
  SMH__PBEDBATTRIBUTE__KEY__KEY_HUMIDITY_VALUE = 0,
  SMH__PBEDBATTRIBUTE__KEY__KEY_HUMIDITY_MIN = 1,
  SMH__PBEDBATTRIBUTE__KEY__KEY_HUMIDITY_MAX = 2,
  SMH__PBEDBATTRIBUTE__KEY__KEY_IAS_TYPE = 1,
  SMH__PBEDBATTRIBUTE__KEY__KEY_IAS_STATUS = 2,
  SMH__PBEDBATTRIBUTE__KEY__KEY_SIREN_MAX_DURATION = 0
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBATTRIBUTE__KEY)
} SMH__PBEDBAttribute__Key;
typedef enum _SMH__PBEDBAttribute__PowerSource {
  SMH__PBEDBATTRIBUTE__POWER_SOURCE__POWER_SOURCE_UNKNOWN = 0,
  SMH__PBEDBATTRIBUTE__POWER_SOURCE__POWER_SOURCE_MAINS_1 = 1,
  SMH__PBEDBATTRIBUTE__POWER_SOURCE__POWER_SOURCE_MAINS_3 = 2,
  SMH__PBEDBATTRIBUTE__POWER_SOURCE__POWER_SOURCE_BATTERY = 3,
  SMH__PBEDBATTRIBUTE__POWER_SOURCE__POWER_SOURCE_DC = 4,
  SMH__PBEDBATTRIBUTE__POWER_SOURCE__POWER_SOURCE_EMERGENCY_CONST = 5,
  SMH__PBEDBATTRIBUTE__POWER_SOURCE__POWER_SOURCE_EMERGENCY_SWITCH = 6,
  SMH__PBEDBATTRIBUTE__POWER_SOURCE__POWER_SOURCE_BACKUP = 128
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBATTRIBUTE__POWER_SOURCE)
} SMH__PBEDBAttribute__PowerSource;
typedef enum _SMH__PBEDBAttribute__ColorMode {
  SMH__PBEDBATTRIBUTE__COLOR_MODE__COLOR_MODE_HUE_SATURATION = 0,
  SMH__PBEDBATTRIBUTE__COLOR_MODE__COLOR_MODE_XY = 1,
  SMH__PBEDBATTRIBUTE__COLOR_MODE__COLOR_MODE_TEMPERATURE = 2
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBATTRIBUTE__COLOR_MODE)
} SMH__PBEDBAttribute__ColorMode;
typedef enum _SMH__PBEDBAttribute__IASStatus {
  SMH__PBEDBATTRIBUTE__IASSTATUS__IAS_STATUS_NONE = 0,
  SMH__PBEDBATTRIBUTE__IASSTATUS__IAS_STATUS_ALARM_1 = 1
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBATTRIBUTE__IASSTATUS)
} SMH__PBEDBAttribute__IASStatus;
typedef enum _SMH__PBEDBBinding__ObjectType {
  SMH__PBEDBBINDING__OBJECT_TYPE__OBJECT_TYPE_NONE = 0,
  SMH__PBEDBBINDING__OBJECT_TYPE__OBJECT_TYPE_MODE = 1,
  SMH__PBEDBBINDING__OBJECT_TYPE__OBJECT_TYPE_SCRIPT = 2
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBBINDING__OBJECT_TYPE)
} SMH__PBEDBBinding__ObjectType;
typedef enum _SMH__PBEDBBinding__CommandID {
  SMH__PBEDBBINDING__COMMAND_ID__COMMAND_ID_NONE = 0,
  SMH__PBEDBBINDING__COMMAND_ID__COMMAND_ID_ACTIVATE = 1,
  SMH__PBEDBBINDING__COMMAND_ID__COMMAND_ID_DEACTIVATE = 2
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBBINDING__COMMAND_ID)
} SMH__PBEDBBinding__CommandID;
typedef enum _SMH__PBEDBAutomation__Type {
  SMH__PBEDBAUTOMATION__TYPE__TYPE_NONE = 0,
  SMH__PBEDBAUTOMATION__TYPE__TYPE_SCRIPT = 1,
  SMH__PBEDBAUTOMATION__TYPE__TYPE_MODE = 2
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBAUTOMATION__TYPE)
} SMH__PBEDBAutomation__Type;
typedef enum _SMH__PBEDBAutomation__ScriptTemplate {
  SMH__PBEDBAUTOMATION__SCRIPT_TEMPLATE__SCRIPT_TEMPLATE_NONE = 0,
  SMH__PBEDBAUTOMATION__SCRIPT_TEMPLATE__SCRIPT_TEMPLATE_TIME = 1,
  SMH__PBEDBAUTOMATION__SCRIPT_TEMPLATE__SCRIPT_TEMPLATE_PRESS = 2,
  SMH__PBEDBAUTOMATION__SCRIPT_TEMPLATE__SCRIPT_TEMPLATE_ALERT = 3,
  SMH__PBEDBAUTOMATION__SCRIPT_TEMPLATE__SCRIPT_TEMPLATE_TEMPERATURE = 4,
  SMH__PBEDBAUTOMATION__SCRIPT_TEMPLATE__SCRIPT_TEMPLATE_COMPLEX = 5,
  SMH__PBEDBAUTOMATION__SCRIPT_TEMPLATE__SCRIPT_TEMPLATE_CUSTOM = 6
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBAUTOMATION__SCRIPT_TEMPLATE)
} SMH__PBEDBAutomation__ScriptTemplate;
typedef enum _SMH__PBEDBAutomation__ModeType {
  SMH__PBEDBAUTOMATION__MODE_TYPE__MODE_TYPE_NONE = 0
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBAUTOMATION__MODE_TYPE)
} SMH__PBEDBAutomation__ModeType;
typedef enum _SMH__PBEDBAutomation__ModeSign {
  SMH__PBEDBAUTOMATION__MODE_SIGN__MODE_SIGN_NONE = 0
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBAUTOMATION__MODE_SIGN)
} SMH__PBEDBAutomation__ModeSign;
typedef enum _SMH__PBEDBScheduler__Weekday {
  SMH__PBEDBSCHEDULER__WEEKDAY__WEEKDAY_NONE = 0,
  SMH__PBEDBSCHEDULER__WEEKDAY__WEEKDAY_MONDAY = 1,
  SMH__PBEDBSCHEDULER__WEEKDAY__WEEKDAY_TUESDAY = 2,
  SMH__PBEDBSCHEDULER__WEEKDAY__WEEKDAY_WEDNESDAY = 3,
  SMH__PBEDBSCHEDULER__WEEKDAY__WEEKDAY_THURSDAY = 4,
  SMH__PBEDBSCHEDULER__WEEKDAY__WEEKDAY_FRIDAY = 5,
  SMH__PBEDBSCHEDULER__WEEKDAY__WEEKDAY_SATURDAY = 6,
  SMH__PBEDBSCHEDULER__WEEKDAY__WEEKDAY_SUNDAY = 7
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBSCHEDULER__WEEKDAY)
} SMH__PBEDBScheduler__Weekday;
typedef enum _SMH__PBEDBAction__Moment {
  SMH__PBEDBACTION__MOMENT__MOMENT_NONE = 0,
  SMH__PBEDBACTION__MOMENT__MOMENT_BEGIN = 1,
  SMH__PBEDBACTION__MOMENT__MOMENT_MIDDLE = 2,
  SMH__PBEDBACTION__MOMENT__MOMENT_END = 3
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBACTION__MOMENT)
} SMH__PBEDBAction__Moment;
typedef enum _SMH__PBEDBAction__Notification {
  SMH__PBEDBACTION__NOTIFICATION__NOTIFICATION_NONE = 0,
  SMH__PBEDBACTION__NOTIFICATION__NOTIFICATION_TV = 1,
  SMH__PBEDBACTION__NOTIFICATION__NOTIFICATION_PUSH = 2,
  SMH__PBEDBACTION__NOTIFICATION__NOTIFICATION_SMS = 3
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBACTION__NOTIFICATION)
} SMH__PBEDBAction__Notification;
typedef enum _SMH__PBEDBCondition__Relation {
  SMH__PBEDBCONDITION__RELATION__RELATION_EQUAL = 0,
  SMH__PBEDBCONDITION__RELATION__RELATION_LESS = -1,
  SMH__PBEDBCONDITION__RELATION__RELATION_GREATER = 1,
  SMH__PBEDBCONDITION__RELATION__RELATION_AND = 2,
  SMH__PBEDBCONDITION__RELATION__RELATION_NOT_AND = 3
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBCONDITION__RELATION)
} SMH__PBEDBCondition__Relation;
typedef enum _SMH__PBEDBSubscriber__Type {
  SMH__PBEDBSUBSCRIBER__TYPE__TYPE_NONE = 0,
  SMH__PBEDBSUBSCRIBER__TYPE__TYPE_PUSH = 1,
  SMH__PBEDBSUBSCRIBER__TYPE__TYPE_SMS = 2
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBSUBSCRIBER__TYPE)
} SMH__PBEDBSubscriber__Type;
typedef enum _SMH__PBEDBSubscriber__SMSStatus {
  SMH__PBEDBSUBSCRIBER__SMSSTATUS__SMS_STATUS_NONE = 0,
  SMH__PBEDBSUBSCRIBER__SMSSTATUS__SMS_STATUS_CONFIRMED = 1
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBSUBSCRIBER__SMSSTATUS)
} SMH__PBEDBSubscriber__SMSStatus;
typedef enum _SMH__PBEDBEvent__Type {
  SMH__PBEDBEVENT__TYPE__TYPE_DEVICE = 0,
  SMH__PBEDBEVENT__TYPE__TYPE_GROUP = 1,
  SMH__PBEDBEVENT__TYPE__TYPE_DONGLE = 2,
  SMH__PBEDBEVENT__TYPE__TYPE_SCRIPT = 3,
  SMH__PBEDBEVENT__TYPE__TYPE_MODE = 4
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBEVENT__TYPE)
} SMH__PBEDBEvent__Type;
typedef enum _SMH__PBEDBCommand__Key {
  SMH__PBEDBCOMMAND__KEY__KEY_ON_OFF_OFF = 0,
  SMH__PBEDBCOMMAND__KEY__KEY_ON_OFF_ON = 1,
  SMH__PBEDBCOMMAND__KEY__KEY_ON_OFF_TOGGLE = 2,
  SMH__PBEDBCOMMAND__KEY__KEY_LEVEL_VALUE = 0,
  SMH__PBEDBCOMMAND__KEY__KEY_COLOR_SATURATION = 3,
  SMH__PBEDBCOMMAND__KEY__KEY_COLOR_HUE_SATURATION = 6,
  SMH__PBEDBCOMMAND__KEY__KEY_COLOR_TEMPERATURE = 10,
  SMH__PBEDBCOMMAND__KEY__KEY_SIREN_WARN = 0,
  SMH__PBEDBCOMMAND__KEY__KEY_SCRIPT_OFF = 0,
  SMH__PBEDBCOMMAND__KEY__KEY_SCRIPT_ON = 1,
  SMH__PBEDBCOMMAND__KEY__KEY_SCRIPT_ON_UNCONDITIONAL = 2
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBCOMMAND__KEY)
} SMH__PBEDBCommand__Key;
typedef enum _SMH__PBEDBCommand__SirenWarning {
  SMH__PBEDBCOMMAND__SIREN_WARNING__SIREN_WARNING_NONE = 0,
  SMH__PBEDBCOMMAND__SIREN_WARNING__SIREN_WARNING_STROBE = 4,
  SMH__PBEDBCOMMAND__SIREN_WARNING__SIREN_WARNING_ALARM = 16
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(SMH__PBEDBCOMMAND__SIREN_WARNING)
} SMH__PBEDBCommand__SirenWarning;

/* --- messages --- */

struct  _SMH__PBEDB
{
  ProtobufCMessage base;
  char *model_name;
  char *user_friendly_model_name;
  char *hardware_id;
  char *software_version;
  char *serial_number;
  int32_t offset;
  char *dre_id;
  char *api_version;
  char *version;
  char *hw_revision;
  SMH__PBEDB__Partition partition;
  int32_t step;
  char *active_client;
  char *session_id;
  uint32_t room_id;
  uint32_t peripheral_id;
  uint32_t automation_id;
  uint32_t scheduler_id;
  uint32_t action_id;
  uint32_t condition_id;
  uint32_t subscriber_id;
  uint32_t update_id;
  size_t n_services;
  SMH__PBEDBService **services;
  size_t n_rooms;
  SMH__PBEDBRoom **rooms;
  size_t n_peripherals;
  SMH__PBEDBPeripheral **peripherals;
  size_t n_automations;
  SMH__PBEDBAutomation **automations;
  size_t n_schedulers;
  SMH__PBEDBScheduler **schedulers;
  size_t n_actions;
  SMH__PBEDBAction **actions;
  size_t n_conditions;
  SMH__PBEDBCondition **conditions;
  size_t n_subscribers;
  SMH__PBEDBSubscriber **subscribers;
  size_t n_updates;
  SMH__PBEDBUpdate **updates;
};
#define SMH__PBEDB__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedb__descriptor) \
    , (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, 0, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, SMH__PBEDB__PARTITION__PARTITION_DASHBOARD, 0, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, 0, 0, 0, 0, 0, 0, 0, 0, 0,NULL, 0,NULL, 0,NULL, 0,NULL, 0,NULL, 0,NULL, 0,NULL, 0,NULL, 0,NULL }


struct  _SMH__PBEDBService
{
  ProtobufCMessage base;
  uint32_t id;
  int32_t state;
  char *message;
};
#define SMH__PBEDBSERVICE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbservice__descriptor) \
    , 0, 0, (char *)protobuf_c_empty_string }


struct  _SMH__PBEDBRoom
{
  ProtobufCMessage base;
  uint32_t id;
  char *name;
  SMH__PBEDBRoom__Type type;
  uint32_t photo;
  char *photo_md5;
};
#define SMH__PBEDBROOM__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbroom__descriptor) \
    , 0, (char *)protobuf_c_empty_string, SMH__PBEDBROOM__TYPE__TYPE_NONE, 0, (char *)protobuf_c_empty_string }


struct  _SMH__PBEDBPeripheral
{
  ProtobufCMessage base;
  SMH__PBEDBPeripheral__Type type;
  uint32_t id;
  char *name;
  int32_t x;
  int32_t y;
  int32_t z;
  uint32_t room;
  SMH__PBEDBPeripheral__GroupType group_type;
  SMH__PBEDBPeripheral__GroupSign group_sign;
  int32_t undev;
  int32_t undev_address;
  int32_t composite_serial;
  SMH__PBEDBPeripheral__DeviceType device_type;
  uint32_t peripheral;
  SMH__PBEDBPeripheral__DeviceCategory device_category;
  SMH__PBEDBPeripheral__DeviceSign device_sign;
  size_t n_clusters;
  SMH__PBEDBCluster **clusters;
  size_t n_bindings;
  SMH__PBEDBBinding **bindings;
};
#define SMH__PBEDBPERIPHERAL__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbperipheral__descriptor) \
    , SMH__PBEDBPERIPHERAL__TYPE__TYPE_NONE, 0, (char *)protobuf_c_empty_string, 0, 0, 0, 0, SMH__PBEDBPERIPHERAL__GROUP_TYPE__GROUP_TYPE_NONE, SMH__PBEDBPERIPHERAL__GROUP_SIGN__GROUP_SIGN_NONE, 0, 0, 0, SMH__PBEDBPERIPHERAL__DEVICE_TYPE__DEVICE_TYPE_NONE, 0, SMH__PBEDBPERIPHERAL__DEVICE_CATEGORY__DEVICE_CATEGORY_NONE, SMH__PBEDBPERIPHERAL__DEVICE_SIGN__DEVICE_SIGN_NONE, 0,NULL, 0,NULL }


struct  _SMH__PBEDBCluster
{
  ProtobufCMessage base;
  SMH__PBEDBCluster__ID id;
  int32_t output;
  size_t n_attributes;
  SMH__PBEDBAttribute **attributes;
};
#define SMH__PBEDBCLUSTER__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbcluster__descriptor) \
    , SMH__PBEDBCLUSTER__ID__ID_BASIC, 0, 0,NULL }


struct  _SMH__PBEDBAttribute
{
  ProtobufCMessage base;
  SMH__PBEDBAttribute__Key key;
  char *str_value;
  int32_t num_value;
};
#define SMH__PBEDBATTRIBUTE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbattribute__descriptor) \
    , SMH__PBEDBATTRIBUTE__KEY__KEY_BASIC_ZCL_VERSIONS, (char *)protobuf_c_empty_string, 0 }


struct  _SMH__PBEDBBinding
{
  ProtobufCMessage base;
  uint32_t key_id;
  SMH__PBEDBBinding__ObjectType object_type;
  uint32_t object_id;
  SMH__PBEDBBinding__CommandID command_id;
};
#define SMH__PBEDBBINDING__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbbinding__descriptor) \
    , 0, SMH__PBEDBBINDING__OBJECT_TYPE__OBJECT_TYPE_NONE, 0, SMH__PBEDBBINDING__COMMAND_ID__COMMAND_ID_NONE }


struct  _SMH__PBEDBAutomation
{
  ProtobufCMessage base;
  SMH__PBEDBAutomation__Type type;
  uint32_t id;
  char *name;
  int32_t on;
  int32_t script_favorite;
  SMH__PBEDBAutomation__ScriptTemplate script_template;
  SMH__PBEDBAutomation__ModeType mode_type;
  SMH__PBEDBAutomation__ModeSign mode_sign;
};
#define SMH__PBEDBAUTOMATION__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbautomation__descriptor) \
    , SMH__PBEDBAUTOMATION__TYPE__TYPE_NONE, 0, (char *)protobuf_c_empty_string, 0, 0, SMH__PBEDBAUTOMATION__SCRIPT_TEMPLATE__SCRIPT_TEMPLATE_NONE, SMH__PBEDBAUTOMATION__MODE_TYPE__MODE_TYPE_NONE, SMH__PBEDBAUTOMATION__MODE_SIGN__MODE_SIGN_NONE }


struct  _SMH__PBEDBScheduler
{
  ProtobufCMessage base;
  SMH__PBEDBAutomation__Type type;
  uint32_t id;
  uint32_t automation;
  int32_t repeat;
  char *start_time;
  char *end_time;
  size_t n_weekdays;
  SMH__PBEDBScheduler__Weekday *weekdays;
};
#define SMH__PBEDBSCHEDULER__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbscheduler__descriptor) \
    , SMH__PBEDBAUTOMATION__TYPE__TYPE_NONE, 0, 0, 0, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, 0,NULL }


struct  _SMH__PBEDBAction
{
  ProtobufCMessage base;
  SMH__PBEDBAutomation__Type type;
  uint32_t id;
  int32_t number;
  SMH__PBEDBCluster__ID cluster;
  SMH__PBEDBCommand__Key command;
  uint32_t automation;
  SMH__PBEDBAction__Moment moment;
  size_t n_parameters;
  int32_t *parameters;
  size_t n_devices;
  uint32_t *devices;
  size_t n_groups;
  uint32_t *groups;
};
#define SMH__PBEDBACTION__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbaction__descriptor) \
    , SMH__PBEDBAUTOMATION__TYPE__TYPE_NONE, 0, 0, SMH__PBEDBCLUSTER__ID__ID_BASIC, SMH__PBEDBCOMMAND__KEY__KEY_ON_OFF_OFF, 0, SMH__PBEDBACTION__MOMENT__MOMENT_NONE, 0,NULL, 0,NULL, 0,NULL }


struct  _SMH__PBEDBCondition
{
  ProtobufCMessage base;
  SMH__PBEDBAutomation__Type type;
  uint32_t id;
  uint32_t peripheral;
  uint32_t automation;
  SMH__PBEDBCluster__ID cluster;
  SMH__PBEDBAttribute__Key attribute;
  int32_t value;
  SMH__PBEDBCondition__Relation relation;
  SMH__PBEDBAction__Moment moment;
};
#define SMH__PBEDBCONDITION__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbcondition__descriptor) \
    , SMH__PBEDBAUTOMATION__TYPE__TYPE_NONE, 0, 0, 0, SMH__PBEDBCLUSTER__ID__ID_BASIC, SMH__PBEDBATTRIBUTE__KEY__KEY_BASIC_ZCL_VERSIONS, 0, SMH__PBEDBCONDITION__RELATION__RELATION_EQUAL, SMH__PBEDBACTION__MOMENT__MOMENT_NONE }


struct  _SMH__PBEDBSubscriber
{
  ProtobufCMessage base;
  SMH__PBEDBSubscriber__Type type;
  uint32_t id;
  char *registration_token;
  char *hw_id;
  char *name;
  char *os;
  int32_t stb_disconnect;
  uint32_t duration;
  char *phone_number;
  SMH__PBEDBSubscriber__SMSStatus sms_status;
};
#define SMH__PBEDBSUBSCRIBER__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbsubscriber__descriptor) \
    , SMH__PBEDBSUBSCRIBER__TYPE__TYPE_NONE, 0, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, 0, 0, (char *)protobuf_c_empty_string, SMH__PBEDBSUBSCRIBER__SMSSTATUS__SMS_STATUS_NONE }


struct  _SMH__PBEDBUpdate
{
  ProtobufCMessage base;
  uint32_t id;
};
#define SMH__PBEDBUPDATE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbupdate__descriptor) \
    , 0 }


struct  _SMH__PBEDBEvent
{
  ProtobufCMessage base;
  SMH__PBEDBEvent__Type type;
  uint32_t object_id;
  SMH__PBEDBCluster__ID cluster;
  SMH__PBEDBAttribute__Key attribute;
  char *str_value;
  int32_t num_value;
};
#define SMH__PBEDBEVENT__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbevent__descriptor) \
    , SMH__PBEDBEVENT__TYPE__TYPE_DEVICE, 0, SMH__PBEDBCLUSTER__ID__ID_BASIC, SMH__PBEDBATTRIBUTE__KEY__KEY_BASIC_ZCL_VERSIONS, (char *)protobuf_c_empty_string, 0 }


struct  _SMH__PBEDBCommand
{
  ProtobufCMessage base;
  SMH__PBEDBCommand__Key key;
  size_t n_parameters;
  int32_t *parameters;
};
#define SMH__PBEDBCOMMAND__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&smh__pbedbcommand__descriptor) \
    , SMH__PBEDBCOMMAND__KEY__KEY_ON_OFF_OFF, 0,NULL }


/* SMH__PBEDB methods */
void   smh__pbedb__init
                     (SMH__PBEDB         *message);
size_t smh__pbedb__get_packed_size
                     (const SMH__PBEDB   *message);
size_t smh__pbedb__pack
                     (const SMH__PBEDB   *message,
                      uint8_t             *out);
size_t smh__pbedb__pack_to_buffer
                     (const SMH__PBEDB   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDB *
       smh__pbedb__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedb__free_unpacked
                     (SMH__PBEDB *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBService methods */
void   smh__pbedbservice__init
                     (SMH__PBEDBService         *message);
size_t smh__pbedbservice__get_packed_size
                     (const SMH__PBEDBService   *message);
size_t smh__pbedbservice__pack
                     (const SMH__PBEDBService   *message,
                      uint8_t             *out);
size_t smh__pbedbservice__pack_to_buffer
                     (const SMH__PBEDBService   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBService *
       smh__pbedbservice__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbservice__free_unpacked
                     (SMH__PBEDBService *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBRoom methods */
void   smh__pbedbroom__init
                     (SMH__PBEDBRoom         *message);
size_t smh__pbedbroom__get_packed_size
                     (const SMH__PBEDBRoom   *message);
size_t smh__pbedbroom__pack
                     (const SMH__PBEDBRoom   *message,
                      uint8_t             *out);
size_t smh__pbedbroom__pack_to_buffer
                     (const SMH__PBEDBRoom   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBRoom *
       smh__pbedbroom__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbroom__free_unpacked
                     (SMH__PBEDBRoom *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBPeripheral methods */
void   smh__pbedbperipheral__init
                     (SMH__PBEDBPeripheral         *message);
size_t smh__pbedbperipheral__get_packed_size
                     (const SMH__PBEDBPeripheral   *message);
size_t smh__pbedbperipheral__pack
                     (const SMH__PBEDBPeripheral   *message,
                      uint8_t             *out);
size_t smh__pbedbperipheral__pack_to_buffer
                     (const SMH__PBEDBPeripheral   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBPeripheral *
       smh__pbedbperipheral__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbperipheral__free_unpacked
                     (SMH__PBEDBPeripheral *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBCluster methods */
void   smh__pbedbcluster__init
                     (SMH__PBEDBCluster         *message);
size_t smh__pbedbcluster__get_packed_size
                     (const SMH__PBEDBCluster   *message);
size_t smh__pbedbcluster__pack
                     (const SMH__PBEDBCluster   *message,
                      uint8_t             *out);
size_t smh__pbedbcluster__pack_to_buffer
                     (const SMH__PBEDBCluster   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBCluster *
       smh__pbedbcluster__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbcluster__free_unpacked
                     (SMH__PBEDBCluster *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBAttribute methods */
void   smh__pbedbattribute__init
                     (SMH__PBEDBAttribute         *message);
size_t smh__pbedbattribute__get_packed_size
                     (const SMH__PBEDBAttribute   *message);
size_t smh__pbedbattribute__pack
                     (const SMH__PBEDBAttribute   *message,
                      uint8_t             *out);
size_t smh__pbedbattribute__pack_to_buffer
                     (const SMH__PBEDBAttribute   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBAttribute *
       smh__pbedbattribute__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbattribute__free_unpacked
                     (SMH__PBEDBAttribute *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBBinding methods */
void   smh__pbedbbinding__init
                     (SMH__PBEDBBinding         *message);
size_t smh__pbedbbinding__get_packed_size
                     (const SMH__PBEDBBinding   *message);
size_t smh__pbedbbinding__pack
                     (const SMH__PBEDBBinding   *message,
                      uint8_t             *out);
size_t smh__pbedbbinding__pack_to_buffer
                     (const SMH__PBEDBBinding   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBBinding *
       smh__pbedbbinding__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbbinding__free_unpacked
                     (SMH__PBEDBBinding *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBAutomation methods */
void   smh__pbedbautomation__init
                     (SMH__PBEDBAutomation         *message);
size_t smh__pbedbautomation__get_packed_size
                     (const SMH__PBEDBAutomation   *message);
size_t smh__pbedbautomation__pack
                     (const SMH__PBEDBAutomation   *message,
                      uint8_t             *out);
size_t smh__pbedbautomation__pack_to_buffer
                     (const SMH__PBEDBAutomation   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBAutomation *
       smh__pbedbautomation__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbautomation__free_unpacked
                     (SMH__PBEDBAutomation *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBScheduler methods */
void   smh__pbedbscheduler__init
                     (SMH__PBEDBScheduler         *message);
size_t smh__pbedbscheduler__get_packed_size
                     (const SMH__PBEDBScheduler   *message);
size_t smh__pbedbscheduler__pack
                     (const SMH__PBEDBScheduler   *message,
                      uint8_t             *out);
size_t smh__pbedbscheduler__pack_to_buffer
                     (const SMH__PBEDBScheduler   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBScheduler *
       smh__pbedbscheduler__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbscheduler__free_unpacked
                     (SMH__PBEDBScheduler *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBAction methods */
void   smh__pbedbaction__init
                     (SMH__PBEDBAction         *message);
size_t smh__pbedbaction__get_packed_size
                     (const SMH__PBEDBAction   *message);
size_t smh__pbedbaction__pack
                     (const SMH__PBEDBAction   *message,
                      uint8_t             *out);
size_t smh__pbedbaction__pack_to_buffer
                     (const SMH__PBEDBAction   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBAction *
       smh__pbedbaction__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbaction__free_unpacked
                     (SMH__PBEDBAction *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBCondition methods */
void   smh__pbedbcondition__init
                     (SMH__PBEDBCondition         *message);
size_t smh__pbedbcondition__get_packed_size
                     (const SMH__PBEDBCondition   *message);
size_t smh__pbedbcondition__pack
                     (const SMH__PBEDBCondition   *message,
                      uint8_t             *out);
size_t smh__pbedbcondition__pack_to_buffer
                     (const SMH__PBEDBCondition   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBCondition *
       smh__pbedbcondition__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbcondition__free_unpacked
                     (SMH__PBEDBCondition *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBSubscriber methods */
void   smh__pbedbsubscriber__init
                     (SMH__PBEDBSubscriber         *message);
size_t smh__pbedbsubscriber__get_packed_size
                     (const SMH__PBEDBSubscriber   *message);
size_t smh__pbedbsubscriber__pack
                     (const SMH__PBEDBSubscriber   *message,
                      uint8_t             *out);
size_t smh__pbedbsubscriber__pack_to_buffer
                     (const SMH__PBEDBSubscriber   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBSubscriber *
       smh__pbedbsubscriber__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbsubscriber__free_unpacked
                     (SMH__PBEDBSubscriber *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBUpdate methods */
void   smh__pbedbupdate__init
                     (SMH__PBEDBUpdate         *message);
size_t smh__pbedbupdate__get_packed_size
                     (const SMH__PBEDBUpdate   *message);
size_t smh__pbedbupdate__pack
                     (const SMH__PBEDBUpdate   *message,
                      uint8_t             *out);
size_t smh__pbedbupdate__pack_to_buffer
                     (const SMH__PBEDBUpdate   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBUpdate *
       smh__pbedbupdate__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbupdate__free_unpacked
                     (SMH__PBEDBUpdate *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBEvent methods */
void   smh__pbedbevent__init
                     (SMH__PBEDBEvent         *message);
size_t smh__pbedbevent__get_packed_size
                     (const SMH__PBEDBEvent   *message);
size_t smh__pbedbevent__pack
                     (const SMH__PBEDBEvent   *message,
                      uint8_t             *out);
size_t smh__pbedbevent__pack_to_buffer
                     (const SMH__PBEDBEvent   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBEvent *
       smh__pbedbevent__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbevent__free_unpacked
                     (SMH__PBEDBEvent *message,
                      ProtobufCAllocator *allocator);
/* SMH__PBEDBCommand methods */
void   smh__pbedbcommand__init
                     (SMH__PBEDBCommand         *message);
size_t smh__pbedbcommand__get_packed_size
                     (const SMH__PBEDBCommand   *message);
size_t smh__pbedbcommand__pack
                     (const SMH__PBEDBCommand   *message,
                      uint8_t             *out);
size_t smh__pbedbcommand__pack_to_buffer
                     (const SMH__PBEDBCommand   *message,
                      ProtobufCBuffer     *buffer);
SMH__PBEDBCommand *
       smh__pbedbcommand__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   smh__pbedbcommand__free_unpacked
                     (SMH__PBEDBCommand *message,
                      ProtobufCAllocator *allocator);
/* --- per-message closures --- */

typedef void (*SMH__PBEDB_Closure)
                 (const SMH__PBEDB *message,
                  void *closure_data);
typedef void (*SMH__PBEDBService_Closure)
                 (const SMH__PBEDBService *message,
                  void *closure_data);
typedef void (*SMH__PBEDBRoom_Closure)
                 (const SMH__PBEDBRoom *message,
                  void *closure_data);
typedef void (*SMH__PBEDBPeripheral_Closure)
                 (const SMH__PBEDBPeripheral *message,
                  void *closure_data);
typedef void (*SMH__PBEDBCluster_Closure)
                 (const SMH__PBEDBCluster *message,
                  void *closure_data);
typedef void (*SMH__PBEDBAttribute_Closure)
                 (const SMH__PBEDBAttribute *message,
                  void *closure_data);
typedef void (*SMH__PBEDBBinding_Closure)
                 (const SMH__PBEDBBinding *message,
                  void *closure_data);
typedef void (*SMH__PBEDBAutomation_Closure)
                 (const SMH__PBEDBAutomation *message,
                  void *closure_data);
typedef void (*SMH__PBEDBScheduler_Closure)
                 (const SMH__PBEDBScheduler *message,
                  void *closure_data);
typedef void (*SMH__PBEDBAction_Closure)
                 (const SMH__PBEDBAction *message,
                  void *closure_data);
typedef void (*SMH__PBEDBCondition_Closure)
                 (const SMH__PBEDBCondition *message,
                  void *closure_data);
typedef void (*SMH__PBEDBSubscriber_Closure)
                 (const SMH__PBEDBSubscriber *message,
                  void *closure_data);
typedef void (*SMH__PBEDBUpdate_Closure)
                 (const SMH__PBEDBUpdate *message,
                  void *closure_data);
typedef void (*SMH__PBEDBEvent_Closure)
                 (const SMH__PBEDBEvent *message,
                  void *closure_data);
typedef void (*SMH__PBEDBCommand_Closure)
                 (const SMH__PBEDBCommand *message,
                  void *closure_data);

/* --- services --- */


/* --- descriptors --- */

extern const ProtobufCMessageDescriptor smh__pbedb__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedb__partition__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbservice__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbroom__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbroom__type__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbperipheral__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbperipheral__type__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbperipheral__group_type__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbperipheral__group_sign__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbperipheral__device_type__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbperipheral__device_category__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbperipheral__device_sign__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbcluster__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbcluster__id__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbattribute__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbattribute__key__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbattribute__power_source__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbattribute__color_mode__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbattribute__iasstatus__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbbinding__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbbinding__object_type__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbbinding__command_id__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbautomation__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbautomation__type__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbautomation__script_template__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbautomation__mode_type__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbautomation__mode_sign__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbscheduler__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbscheduler__weekday__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbaction__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbaction__moment__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbaction__notification__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbcondition__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbcondition__relation__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbsubscriber__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbsubscriber__type__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbsubscriber__smsstatus__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbupdate__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbevent__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbevent__type__descriptor;
extern const ProtobufCMessageDescriptor smh__pbedbcommand__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbcommand__key__descriptor;
extern const ProtobufCEnumDescriptor    smh__pbedbcommand__siren_warning__descriptor;

PROTOBUF_C__END_DECLS


#endif  /* PROTOBUF_C_smhpbedb_2eproto__INCLUDED */
